xref: /freebsd/tests/sys/acl/03.sh (revision 315ee00f)
1#!/bin/sh
2#
3# Copyright (c) 2008, 2009 Edward Tomasz Napierała <trasz@FreeBSD.org>
4#
5# Redistribution and use in source and binary forms, with or without
6# modification, are permitted provided that the following conditions
7# are met:
8# 1. Redistributions of source code must retain the above copyright
9#    notice, this list of conditions and the following disclaimer.
10# 2. Redistributions in binary form must reproduce the above copyright
11#    notice, this list of conditions and the following disclaimer in the
12#    documentation and/or other materials provided with the distribution.
13#
14# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
15# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
16# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
17# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
18# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
19# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
20# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
21# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
22# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
23# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
24# SUCH DAMAGE.
25#
26#
27
28# This is a wrapper script to run tools-crossfs.test between UFS without
29# ACLs, UFS with POSIX.1e ACLs, and ZFS with NFSv4 ACLs.
30#
31# WARNING: It uses hardcoded ZFS pool name "acltools"
32#
33# Output should be obvious.
34
35if ! sysctl vfs.zfs.version.spa >/dev/null 2>&1; then
36	echo "1..0 # SKIP system doesn't have ZFS loaded"
37	exit 0
38fi
39if [ $(id -u) -ne 0 ]; then
40	echo "1..0 # SKIP you must be root"
41	exit 0
42fi
43
44echo "1..5"
45
46TESTDIR=$(dirname $(realpath $0))
47MNTROOT=`mktemp -dt acltools`
48
49# Set up the test filesystems.
50MD1=`mdconfig -at swap -s 64m`
51MNT1=$MNTROOT/nfs4
52mkdir $MNT1
53zpool create -m $MNT1 acltools /dev/$MD1
54if [ $? -ne 0 ]; then
55	echo "not ok 1 - 'zpool create' failed."
56	echo 'Bail out!'
57	exit 1
58fi
59
60echo "ok 1"
61
62MD2=`mdconfig -at swap -s 10m`
63MNT2=$MNTROOT/posix
64mkdir $MNT2
65newfs /dev/$MD2 > /dev/null
66mount -o acls /dev/$MD2 $MNT2
67if [ $? -ne 0 ]; then
68	echo "not ok 2 - mount failed."
69	echo 'Bail out!'
70	exit 1
71fi
72
73echo "ok 2"
74
75MD3=`mdconfig -at swap -s 10m`
76MNT3=$MNTROOT/none
77mkdir $MNT3
78newfs /dev/$MD3 > /dev/null
79mount /dev/$MD3 $MNT3
80if [ $? -ne 0 ]; then
81	echo "not ok 3 - mount failed."
82	echo 'Bail out!'
83	exit 1
84fi
85
86echo "ok 3"
87
88cd $MNTROOT
89
90perl $TESTDIR/run $TESTDIR/tools-crossfs.test >&2
91
92if [ $? -eq 0 ]; then
93	echo "ok 4"
94else
95	echo "not ok 4"
96fi
97
98cd /
99
100umount -f $MNT3
101rmdir $MNT3
102mdconfig -du $MD3
103
104umount -f $MNT2
105rmdir $MNT2
106mdconfig -du $MD2
107
108zpool destroy -f acltools
109rmdir $MNT1
110mdconfig -du $MD1
111
112rmdir $MNTROOT
113
114echo "ok 5"
115
116